// com.digicide.texttwist
// /Applications/TextTwist.app/main.

Plugins.load( "UIKit" );
include ("twistDic.js");
include ("hiscore.js");

var window = new UIWindow( UIHardware.fullScreenApplicationContentRect );
window.setHidden( false );
window.orderFront();
window.makeKey();
window.backgroundColor = [ 0.8 , 0.8 , 0.8, 1 ];

var mainView = new UIView();
window.setContentView( mainView );

var stage = new UIView([0, 0, window.bounds[3], window.bounds[2]]);
stage.setRotationBy(90);

stage.backgroundColor = [0, 0, 0, 0];
stage.position = [0, 0];

back = new UIImageView(new Image("back.png"));
back.position = [0, getY(0)];
stage.addSubview(back);

grid = new UIImageView(new Image("grid.png"));
grid.position = [2, getY(151)];
//stage.addSubview(grid);


function textBoxPos(num)
{
  return 10 + 60 * num;
}

textBoxWidth = 60;

var textScroller = new UIScroller([0, 0, 480, 150]);
textScroller.bounds = [200, getY(200), 480, 150];
textScroller.position = [0, getY(5)];
textScroller.contentSize = [610, 150];
//textScroller.setAdjustForContentSizeChange(true);
textScroller.backgroundColor = [0, 0, 0, 0];
textScroller.setShowScrollerIndicators(false);
textScroller.setAllowsRubberBanding(false);
textScroller.offset = 0;
stage.addSubview(textScroller);

var text0 = new UITextLabel( [0, 0, textBoxWidth, 150] );
text0.position = [textBoxPos(0), 0];
text0.setFont( new Font( "Trebuchet MS" , 2 , 16 ) );
text0.text = "";
text0.wrapsText = true;
text0.backgroundColor = [ 0 , 1 , 0 , 0 ];
text0.color = [ 0 , 0 , .4 , 1 ];
text0.centersHorizontally = false;
textScroller.addSubview(text0);

var text1 = new UITextLabel( [0, 0, textBoxWidth, 150] );
text1.position = [textBoxPos(1), 0];
text1.setFont( new Font( "Trebuchet MS" , 2 , 16 ) );
text1.text = "";
text1.wrapsText = true;
text1.backgroundColor = [ 0 , 1 , 0 , 0 ];
text1.color = [ 0 , 0 , .4 , 1 ];
text1.centersHorizontally = false;
textScroller.addSubview(text1);

var text2 = new UITextLabel( [0, 0, textBoxWidth, 150] );
text2.position = [textBoxPos(2), 0];
text2.setFont( new Font( "Trebuchet MS" , 2 , 16 ) );
text2.text = "";
text2.wrapsText = true;
text2.backgroundColor = [ 0 , 1 , 0 , 0 ];
text2.color = [ 0 , 0 , .4 , 1 ];
text2.centersHorizontally = false;
textScroller.addSubview(text2);

var text3 = new UITextLabel( [0, 0, textBoxWidth, 150] );
text3.position = [textBoxPos(3), 0];
text3.setFont( new Font( "Trebuchet MS" , 2 , 16 ) );
text3.text = "";
text3.wrapsText = true;
text3.backgroundColor = [ 0 , 1 , 0 , 0 ];
text3.color = [ 0 , 0 , .4 , 1 ];
text3.centersHorizontally = false;
textScroller.addSubview(text3);

var text4 = new UITextLabel( [0, 0, textBoxWidth, 150] );
text4.position = [textBoxPos(4), 0];
text4.setFont( new Font( "Trebuchet MS" , 2 , 16 ) );
text4.text = "";
text4.wrapsText = true;
text4.backgroundColor = [ 0 , 1 , 0 , 0 ];
text4.color = [ 0 , 0 , .4 , 1 ];
text4.centersHorizontally = false;
textScroller.addSubview(text4);

var text5 = new UITextLabel( [0, 0, textBoxWidth, 150] );
text5.position = [textBoxPos(5), 0];
text5.setFont( new Font( "Trebuchet MS" , 2 , 16 ) );
text5.text = "";
text5.wrapsText = true;
text5.backgroundColor = [ 0 , 1 , 0 , 0 ];
text5.color = [ 0 , 0 , .4 , 1 ];
text5.centersHorizontally = false;
textScroller.addSubview(text5);

var text6 = new UITextLabel( [0, 0, textBoxWidth, 150] );
text6.position = [textBoxPos(6), 0];
text6.setFont( new Font( "Trebuchet MS" , 2 , 16 ) );
text6.text = "";
text6.wrapsText = true;
text6.backgroundColor = [ 0 , 1 , 0 , 0 ];
text6.color = [ 0 , 0 , .4 , 1 ];
text6.centersHorizontally = false;
textScroller.addSubview(text6);

var text7 = new UITextLabel( [0, 0, textBoxWidth, 150] );
text7.position = [textBoxPos(7), 0];
text7.setFont( new Font( "Trebuchet MS" , 2 , 16 ) );
text7.text = "";
text7.wrapsText = true;
text7.backgroundColor = [ 0 , 1 , 0 , 0 ];
text7.color = [ 0 , 0 , .4 , 1 ];
text7.centersHorizontally = false;
textScroller.addSubview(text7);

var text8 = new UITextLabel( [0, 0, textBoxWidth, 150] );
text8.position = [textBoxPos(8), 0];
text8.setFont( new Font( "Trebuchet MS" , 2 , 16 ) );
text8.text = "";
text8.wrapsText = true;
text8.backgroundColor = [ 0 , 1 , 0 , 0 ];
text8.color = [ 0 , 0 , .4 , 1 ];
text8.centersHorizontally = false;
textScroller.addSubview(text8);

var text9 = new UITextLabel( [0, 0, textBoxWidth, 150] );
text9.position = [textBoxPos(9), 0];
text9.setFont( new Font( "Trebuchet MS" , 2 , 16 ) );
text9.text = "";
text9.wrapsText = true;
text9.backgroundColor = [ 0 , 1 , 0 , 0 ];
text9.color = [ 0 , 0 , .4 , 1 ];
text9.centersHorizontally = false;
textScroller.addSubview(text9);

timeScoreBack = new UIHighlightView([340, getY(-30), 150, 75]);
timeScoreBack.setColor([0, 0, .4, .7]);
timeScoreBack.backgroundColor = [0, 0, 0, 0];
timeScoreBack.cornerRadius = 10;
stage.insertSubviewAbove(timeScoreBack, textScroller);

var timeScore = new UITextLabel([0, 28, 150, 45]);
timeScore.setFont( new Font( "Trebuchet MS" , 2 , 18 ) );
timeScore.color = [ 1, 1, 1, 1 ];
timeScore.backgroundColor = [0, 0, 0, 0];
timeScore.wrapsText = true;
timeScore.text = " Time: 2:00\n Score: 0";
//timeScore.cornerRadius = 10;
timeScoreBack.addSubview(timeScore);
timeScore.onMouseDown = timeScoreBack.onMouseDown = function(event)
{
  alert("hey you guys");
}


var blank = new UIImageView(new Image("blank.png"));
blank.bounds = [0, 0, window.bounds[3], window.bounds[2] - 140];
blank.position = [0, getY(140)];
//blank.backgroundColor=[1,0,0,1];

timeScore.alpha = .75;

myAlert = new UIHighlightView();
myAlert.width = 300;
myAlert.height= 150;
myAlert.bounds = [0, 0, myAlert.width, myAlert.height];
myAlert.position = [window.bounds[3]/2 - myAlert.width/2, getY(window.bounds[2]/2 - myAlert.height/2)];
myAlert.setColor = [0, 0, .6, .6];
//stage.addSubview(myAlert);


roundOver = new UIHighlightView([20, getY(170), 420, 140]);
roundOver.backgroundColor = [0, 0, 0, 0];
roundOver.setColor([0, 0, .4, .8]);
roundOver.cornerRadius = 20;
roundOver.origFrame = roundOver.frame;

roundOverText = new UITextLabel([10, 10, 400, 120]);
roundOverText.setFont( new Font( "Trebuchet MS" , 2 , 26 ) );
roundOverText.color = [ 1, 1, 1 , 1 ];
roundOverText.backgroundColor = [ 1, 1, 1 , 0 ];
roundOverText.centersHorizontally = true;
roundOverText.wrapsText = true;
roundOverText.text = "You qualify for the next round!\nTap with two fingers to continue.";
roundOver.alpha = .7;
roundOver.addSubview(roundOverText);
//stage.addSubview(roundOver);

threemessage = new UIImageView(new Image("/messages/90.png"));
threemessage.origFrame = threemessage.frame;
fourmessage = new UIImageView(new Image("/messages/160.png"));
fourmessage.origFrame = fourmessage.frame;
fivemessage = new UIImageView(new Image("/messages/250.png"));
fivemessage.origFrame = fivemessage.frame;
qualifymessage = new UIImageView(new Image("/messages/qualify.png"));
qualifymessage.origFrame = qualifymessage.frame;
nomessage = new UIImageView(new Image("/messages/no.png"));
nomessage.origFrame = nomessage.frame;
againmessage = new UIImageView(new Image("/messages/again.png"));
againmessage.origFrame = againmessage.frame;
allmessage = new UIImageView(new Image("/messages/100percent.png"));
allmessage.origFrame = allmessage.frame;

shockwave0 = new UIImageView(new Image("shockwave.png"));
shockwave0.origFrame = shockwave0.frame;
shockwave1 = new UIImageView(new Image("shockwave.png"));
shockwave1.origFrame = shockwave0.frame;
shockwave2 = new UIImageView(new Image("shockwave.png"));
shockwave2.origFrame = shockwave0.frame;
shockwave3 = new UIImageView(new Image("shockwave.png"));
shockwave3.origFrame = shockwave0.frame;
shockwave4 = new UIImageView(new Image("shockwave.png"));
shockwave4.origFrame = shockwave0.frame;
shockwave5 = new UIImageView(new Image("shockwave.png"));
shockwave5.origFrame = shockwave0.frame;


mainView.addSubview(stage);


/*letter1;
letter2; 
letter3;
letter4;
letter5;
letter6;*/
minutes = 2;
seconds = 0;
theSeconds = "00";
score = 0;
scores = [0, 0, 0, 90, 160, 250, 460];
qualify = false;
roundIsOver = false;


round = new Timer(1);
round.onTimer = function(round)
{
  if(decTimer())
  {
    killRound();
    //newRound();
  }
  theSeconds = seconds;
  if(seconds < 10)
  { 
    theSeconds = "0" + seconds;
  }
  setTimeScore();
}

letters = [new Object(), new Object(), new Object(), new Object(), new Object(), new Object()];
isLandscape = false;
combinations = [];
foundWords = [];
numWordsFound =0;

nullLetter = new Object();
inGrid = [];
onRack = [];
inBoth = [];
theWord = "";
origOrder = [];


function decTimer()
{
  if(seconds == 0)
  {
    if(minutes == 0)
    {
      return true;
    }
    seconds = 59;
    minutes--;
  }
  else
  {
    seconds--;
  }
  return false;
}

function setTimeScore()
{
  timeScore.text = " Time: " + minutes + ":" + theSeconds + "\n Score: " + score;
}

function killRound()
{
  round.stop();
  for(var i = 0; i < foundWords.length; i++)
  {
    if(!foundWords[i])
    {
      foundWords[i] = 2;
    }
  }
  text0.text = getTextBox(0);
  text1.text = getTextBox(1);
  text2.text = getTextBox(2);
  text3.text = getTextBox(3);
  text4.text = getTextBox(4);
  text5.text = getTextBox(5);
  text6.text = getTextBox(6);
  text7.text = getTextBox(7);
  text8.text = getTextBox(8);
  text9.text = getTextBox(9);
  
  for(var i = 0; i < inBoth.length; i++)
  {
     inBoth[i].removeFromSuperview();
  }
  pipHolder.removeFromSuperview();

  inGrid = [];
  onRack = [];
  inBoth = [];
  combinations = [];
  grid.removeFromSuperview();
  if(numWordsFound == foundWords.length)
  {
    roundOverText.text = "You got all the words!  Enjoy a hefty bonus!\nTap with two fingers to continue.";
    score += numWordsFound * 200;
    setTimeScore();
  }
  else if(qualify)
  {
    roundOverText.text = "You qualify for the next round!\nTap with two fingers to continue.";
  }
  else
  {
    if(score > highScore)
    {
      roundOverText.text = "Game Over.\nYou got the high score!\nTap with two fingers to start a new game.";
      hiscore = new Data();
      hiscore.loadFromString(("highScore = " + score + ";"));
      hiscore.writeToFile("hiscore.js");
      highScore = score;
    }
    else
    {
      roundOverText.text = "Game Over!\nYour score was " + score + ".  The high score is " + highScore + ".  Tap with two fingers to try again.";
    }
    score = 0;
  }
  
  roundOver.alpha = 0;
  stage.addSubview(roundOver);
  var animation = new UIAlphaAnimation(roundOver, 0, 0, 1);
  Animator.addAnimation(animation, 1, true);
  
  
  var dumbTimer = new Timer(1);
  dumbTimer.onTimer = function(dumbTimer)
  {
    prepareNewRound();
    this.stop();
  }
  dumbTimer.start();
  
  
  roundIsOver = true;
  foundWords = [];
}

function prepareNewRound()
{
  theWord = getSixLetterWord();
  origOrder = scrambleWord(theWord);
  combinations = getCombinations(theWord);
  combinations.sort(sortByLength);
}

function landscape()
{
  for(var i = 0; i < letters.length; i++)
  {
    letters[i].pos = [8 + 75*i, getY(250)];
  }
  landscape = true;
}

landscape();

var pipHolder = new UIView([0, getY(260), window.bounds[3], 50]);
var pip0 = new UIImageView(new Image("pip.png"));
pip0.position = [letters[0].pos[0] + 11, 0];
pipHolder.addSubview(pip0);
var pip1 = new UIImageView(new Image("pip.png"));
pip1.position = [letters[1].pos[0] + 11, 0];
pipHolder.addSubview(pip1);
var pip2 = new UIImageView(new Image("pip.png"));
pip2.position = [letters[2].pos[0] + 11, 0];
pipHolder.addSubview(pip2);
var pip3 = new UIImageView(new Image("pip.png"));
pip3.position = [letters[3].pos[0] + 11, 0];
pipHolder.addSubview(pip3);
var pip4 = new UIImageView(new Image("pip.png"));
pip4.position = [letters[4].pos[0] + 11, 0];
pipHolder.addSubview(pip4);
var pip5 = new UIImageView(new Image("pip.png"));
pip5.position = [letters[5].pos[0] + 11, 0];
pipHolder.addSubview(pip5);

function portrait()
{

}

function getSixLetterWord()
{
  for(var i = Math.floor(Math.random() * dictionary.length); i < dictionary.length; i++)
  {
    if(dictionary[i].length == 6)
    {
      return dictionary[i];
    }
  }
}

function getCombinations(word)
{
  var toReturn = [];
  for(var i = 0; i < dictionary.length; i++)
  {
    var theWord = word;
    for(var j = 0; j < dictionary[i].length; j++)
    {
      var theLetter = dictionary[i].charAt(j);
      var theIndex = theWord.indexOf(theLetter);
      if(theIndex > -1)
      {
        theWord = theWord.replace(theLetter, "");
        if(j == dictionary[i].length - 1)
        {
          toReturn.push(dictionary[i]);
        }
      }      
      else
      {
        break;
      }
    }
  }
  return toReturn;
}

function arrayToString(collection)
{
  theString = "";
  for(var i = 0; i < collection.length; i++)
  {
    theString += collection[i] + "\n";
  }
  return theString;
}

function sortByLength(a, b)
{
  if(a.length < b.length)
  {
    return -1;
  }
  else if(a.length == b.length)
  {
    if(a < b)
    {
      return -1;
    }
    else if(a == b)
    {
      return 0;
    }
    else
    {
      return 1;
    }
  }
  else
  {
    return 1;
  }
}

function scrambleWord(word)
{
  var wordArray = new Array(word.length);
  var swappedString = "";
  for(var i = 0; i < wordArray.length; i++)
  {
    wordArray[i] = word.charAt(i);
  }
  
  for(var i = 0; i < 15; i++)
  {
    var random1 = Math.floor(Math.random() * word.length);
    var random2 = Math.floor(Math.random() * word.length);
    
    var temp = wordArray[random1];
    
    wordArray[random1] = wordArray[random2];
    wordArray[random2] = temp;
  }
  
  for(var i = 0; i < wordArray.length; i++)
  {
    swappedString += wordArray[i];
  }
  return swappedString;
}

function getY(y)
{
  return y - stage.bounds[3];
}

function newRound()
{
  minutes = 2;
  seconds = 0;
  setTimeScore();
  qualify = false;
  roundIsOver = false;
  numWordsFound = 0;;
  roundOver.removeFromSuperview();
  stage.addSubview(grid);
  stage.addSubview(pipHolder);
  stage.addSubview(blank);
  
  //assumes combinations have already been generated
  /*var theWord = getSixLetterWord();
  var origOrder = scrambleWord(theWord);
  combinations = getCombinations(theWord);
  combinations.sort(sortByLength);*/
  foundWords = new Array(combinations.length);
  for(var i = 0; i < foundWords.length; i++)
  {
    foundWords[i] = false;
  }
  text0.text = getTextBox(0);
  text1.text = getTextBox(1);
  text2.text = getTextBox(2);
  text3.text = getTextBox(3);
  text4.text = getTextBox(4);
  text5.text = getTextBox(5);
  text6.text = getTextBox(6);
  text7.text = getTextBox(7);
  text8.text = getTextBox(8);
  text9.text = getTextBox(9);
  
  var theWord = combinations[combinations.length - 1]; //always six letters
  
  for(var i = 0; i < theWord.length; i++)
  {
    var tempLetter = new UIImageView(new Image("/letters/" + origOrder.charAt(i) + ".png"));
    stage.addSubview(tempLetter);
    tempLetter.position = letters[i].pos;
    onRack.push(tempLetter);
    inBoth.push(tempLetter);
    tempLetter.place = i;
    tempLetter.id = origOrder.charAt(i);
    tempLetter.onMouseDown = function(event)
    {
      onRackTap(this, event);
    }
  }
  round.start();
  return theWord;
}

function onRackTap(target, event)
{
    //flashShockwave(240, getY(160));
    flashShockwave(letters[target.place].pos[0] + 34, letters[0].pos[1] + 34);
    putInGrid(target);
}

function onGridTap(target, event)
{
  if(target == inGrid[inGrid.length - 1]) //correct stupid glitches...
  {
    inGrid.pop();
    var thePlace = -1;
    for(var i = 5; i >= 0; i--)
    {
      if(onRack[i] == nullLetter)
      {
        thePlace = i;
        break;
      }
    }
    onRack[thePlace] = target;
    target.place = thePlace;
    var animation = new UIFrameAnimation(target, 1, target.frame, [letters[target.place].pos[0], letters[target.place].pos[1], target.frame[2], target.frame[3]]);
    Animator.addAnimation(animation, .2, true);
    //target.position = letters[target.place].pos;
    if(inGrid.length)
    {
      inGrid[inGrid.length - 1].onMouseDown = function(event)
      {
        onGridTap(this, event);
      }
    }
    target.onMouseDown = function(event)
    {
      onRackTap(this, event);
    }
  }
}

function putInGrid(letter)
{
  
  inGrid.push(letter);
  letter.onMouseDown = null;
  if(inGrid.length > 1)
  {
    inGrid[inGrid.length - 2].onMouseDown = null;
  }
  var animation = new UIFrameAnimation(letter, 1, letter.frame, [15 + 73*(inGrid.length - 1), getY(165), letter.frame[2], letter.frame[3]]);
  animation.target = letter;
  animation.onStop = function()
  {
    this.target.onMouseDown = function(event)
    {
      onGridTap(this, event);
    }
  }
  Animator.addAnimation(animation, .2, true);
  //letter.position = [15 + 73*inGrid.length, getY(165)]
  onRack[letter.place] = nullLetter;
  
  
}

function setTextBoxForIndex(num)
{
  var theBox = Math.floor(num/8);
  var boxes = [text0, text1, text2, text3, text4, text5, text6, text7, text8, text9];
  boxes[theBox].text = getTextBox(theBox);
}

function getTextBox(num)
{
  var theString = "";
  for(var i = num * 8; i < num*8 + 8 && i < foundWords.length; i++)
  {
    if(!foundWords[i])
    {
      theString += combinations[i].replace(/./g,"¤") + "\n";
    }
    else if(foundWords[i] == 1)
    {
      theString += combinations[i] + "\n";
    }
    else if(foundWords[i] == 2)
    {
      theString += combinations[i].toUpperCase() + "\n";
    }
  }
  return theString;
}

roundOver.onTap = textScroller.onTap = back.onTap = blank.onTap = function(tapCount, fingerCount, event)
{
  if(!roundIsOver && tapCount == 2 && fingerCount == 1)
  {
    doubleTapConfirm(tapCount, fingerCount, event);
  }
  else if(roundIsOver && fingerCount == 2)
  {
    newRound();
  }
}

twistTimer = new Timer(1);
twistTimer.onTimer = function(twistTimer)
{
  this.stop();
  onAccelerate = function(x,y,z){accelerateFunction(x,y,z);}
}
function twist()
{
  onAccelerate = null;
  twistTimer.start();
  var availSpots = [0, 1, 2, 3, 4, 5];
  var onRack2 = onRack.slice();
  for(var i = 0; i < onRack.length; i++)
  {
    var randIndex = Math.floor(Math.random() * (6-i));
    var newSpot = availSpots[randIndex];
    availSpots.splice(randIndex, 1);
    onRack[newSpot] = onRack2[i];
    if(onRack2[i] != nullLetter)
    {
      onRack2[i].place = newSpot;
      var animation = new UIFrameAnimation(onRack2[i], 1, onRack2[i].frame, [letters[newSpot].pos[0], letters[newSpot].pos[1], onRack2[i].frame[2], onRack2[i].frame[3]]);
      Animator.addAnimation(animation, .5, true);
    }
    else
    {
     
    }
  }
}

function doubleTapConfirm(tapCount, fingerCount, event)
{
    var theString = "";
    for(var i = 0; i < inGrid.length; i++)
    {
      theString += inGrid[i].id;
    }
  
    var theIndex = search(combinations, theString);
    if(theString.length && theIndex > -1)
    {
      if(!foundWords[theIndex])
      {
        if(theString.length == 6)
        {
          qualify = true;
        }
        var graphics = [0, 0, 0, threemessage, fourmessage, fivemessage, qualifymessage];
        flashMessage(graphics[theString.length]);
      
        foundWords[theIndex] = 1;
        numWordsFound++;
        
        setTextBoxForIndex(theIndex);
        score += scores[theString.length];
        setTimeScore();
        for(var i = inGrid.length - 1; i >= 0; i--)
        {
          onGridTap(inGrid[i], 1, 1, null);
        }
        if(numWordsFound == foundWords.length)
        {
          flashMessage(allmessage);
          killRound();
        }
        else
        {
          flashMessage(graphics[theString.length]);
        }
      }
      else
      {
        flashMessage(againmessage);
        for(var i = inGrid.length - 1; i >= 0; i--)
        {
          onGridTap(inGrid[i], 1, 1, null);
        }
      }
    }
    else if(theString.length)
    {
      flashMessage(nomessage);
      for(var i = inGrid.length - 1; i >= 0; i--)
      {
        onGridTap(inGrid[i], 1, 1, null);
      }
    }
  
}
//returns index of item in sorted collection
//or negative value of where item would be
function search(collection, item)
{
  for(var i=0; i < collection.length; i++)
  {
    if(collection[i] == item)
    {
      return i;
    }
  }
  return -1;
}

function flashMessage(graphic)
{
  //graphic.bounds = [0, 0, graphic.origFrame[2]/3, graphic.origFrame[3]/3];
  graphic.alpha = .8;
  graphic.bounds = [window.frame[3]/2, getY(window.frame[2]/2), 0, 0];
  var endWidth = graphic.origFrame[2]*4;
  var endHeight = graphic.origFrame[3]*4;
  graphic.position = [window.frame[3]/2, getY(window.frame[2]/2)];
  //graphic.bounds = [window.frame[3]/2 - endWidth/2, getY(window.frame[2]/2 - endHeight/2), endWidth, endHeight]
  //graphic.position = [window.frame[3]/2 - endWidth/2, getY(window.frame[2]/2 - endHeight/2)];
  stage.insertSubviewBelow(graphic, blank);
  var animation = new UIFrameAnimation(graphic, 1, graphic.bounds, [window.frame[3]/2 - endWidth/2, getY(window.frame[2]/2 - endHeight/2), endWidth, endHeight]);
  animation.target = graphic;
  animation.onStop = function()
  {
    this.target.removeFromSuperview();
  }
  var fade = new UIAlphaAnimation(graphic, 1, graphic.alpha, 0);
  Animator.addAnimation(animation, .7, true);
  Animator.addAnimation(fade, .7, true);
}

var shockwaves = [shockwave0, shockwave1, shockwave2, shockwave3, shockwave4, shockwave5];
var usedShockwave = 5;

function flashShockwave(x, y)
{

  //graphic.bounds = [0, 0, graphic.origFrame[2]/3, graphic.origFrame[3]/3];
  var graphic = shockwaves[usedShockwave];
  usedShockwave++;
  if(usedShockwave == 6){usedShockwave = 0;}
  graphic.alpha = 1;
  graphic.bounds = [x - 15, y - 15, 30, 30];
  var endWidth = graphic.origFrame[2]*3;
  var endHeight = graphic.origFrame[3]*3;
  graphic.position = [x, y];
  stage.insertSubviewAbove(graphic, back);
  var animation = new UIFrameAnimation(graphic, 2, graphic.bounds, [x - endWidth/2, y - endHeight/2, endWidth, endHeight]);
  animation.target = graphic;
  animation.onStop = function()
  {
    this.target.removeFromSuperview();
  }
  var fade = new UIAlphaAnimation(graphic, 2, graphic.alpha, .2);
  Animator.addAnimation(animation, .4, true);
  Animator.addAnimation(fade, .4, true);
}

//Monitor the moves.
var last_x;
var last_y;
var last_z;

function accelerateFunction(x, y, z)
{
  if (Math.abs(last_x) - Math.abs(x) > 0.3 || Math.abs(last_y) - Math.abs(y) > 0.3 ) {
    twist();
  }

  last_x = x;
  last_y = y;
  last_z = z;
}

onAccelerate = function( x,y,z )
{
  accelerateFunction(x,y,z);
}


prepareNewRound();
newRound();
